var inited = 0;
var tab = 0;
var tabwidth = 8;
var sec = new Array(2523, 2756, 3872, 2214, 1671, 3124, 4503, 5100, 2116, 1811, 3158, 3781, 4402, 4168, 5491, 1912, 5534, 3074, 3723, 2534, 2144, 4615, 4103, 4676, 1866, 1915, 5462, 4497, 4279, 4833, 3364, 4412, 3559, 3723, 4983, 1726, 4283, 5027, 5257, 3322, 4959, 2703, 5353, 2096, 4469, 2901, 4368, 1685, 3754, 2358, 3828, 2008, 4962, 4064, 1973, 3813, 4486, 3259, 3301, 2070, 1671);
function refreshcount() {
    document.getElementById('count').innerHTML = document.getElementById('content').childNodes.length;
}
function bs(id) {
    if (document.getElementById(id).childNodes.length > 0) {
        var c = document.getElementById(id).childNodes.length, v = document.getElementById(id).childNodes, d = document.getElementById(id);
        d.removeChild(v[c - 1]);
    }
}
function cls(id) {
    if (document.getElementById(id).childNodes.length > 0) {
        var p = document.getElementById(id).parentElement, n = document.createElement('div');
        document.body.style.backgroundColor = '#FFF';
        p.removeChild(document.getElementById(id));
        n.id = id;
        p.appendChild(n);
    }
}
function addchar(id, ccode, alt) {
    var img = document.createElement('img');
    if (ccode == 97) {
        ccode = 267;
    }
    var font = "font1";
    if (ccode > 5599) {
        font = "font2";
        ccode = ccode - 5500;
    };
    if (ccode > 99) {
        var x = ((Math.floor(ccode / 100) - 1) * 192) + (Math.floor((Math.floor(ccode % 100)) / 16) * 32);
        var y = ((ccode % 100) % 16) * 32;
        img.setAttribute('src', './sp.png');
        tab += 2;
    }
    else {
        var x = 1728 + Math.floor(ccode / 16) * 32;
        var y = 256 + (ccode % 16) * 16;
        img.setAttribute('src', './hsp.png');
        tab += 1;
    };
    var style = 'background: url(./' + font + '.png) ' + -y + 'px ' + -x + 'px;';
    img.setAttribute('style', style);
    img.setAttribute('alt', alt);
    if (Math.floor(ccode / 100) != 10 || font == "font2") {
        document.getElementById(id).appendChild(img);
    }
    else {
        var ctrlcode = ccode % 100;
        switch (ctrlcode) {
            case 1:
                var ctrlset = document.createElement("br");
                tab = 0;
                document.getElementById(id).appendChild(ctrlset);
                break;
            case 2:
                tab -= 2;
                otab = tabwidth - tab % tabwidth;
                for (settab = 0; settab < otab; settab++) {
                    var img = document.createElement('img');
                    img.setAttribute('src', './hsp.png');
                    img.setAttribute('alt', ' ');
                    document.getElementById(id).appendChild(img);
                }
                tab += otab;
                break;
            default:
                var ctrlset = document.createElement("span");
                document.getElementById(id).appendChild(ctrlset);
        };

    };
};
function setarrchr(id, enc, arr) {
    var org = 0;
    if (enc == 1) {
        for (i = 0; i < arr.length; i++) {
            org = arr[i] - sec[i % 61];
            if (org < 0) {
                org = org + 10000;
            };
            addchar(id, org, '');
        }
    } else {
        for (i = 0; i < arr.length; i++) {
            addchar(id, arr[i], '');
        }
    };
};

function setstrchr(id, str) {
    console.time(2);
    if (inited == 0) {
        cls('content');
        tab = 0;
        inited = 1;
    }
    var t = '', c = 0;
    for (i = 0; i < str.length; i++) {
        t = str[i];
        c = uniconv(str.charCodeAt(i));
        addchar(id, c, t);
    }
    console.timeEnd(2);
}